local SENSBALLS_VERSION = 1

if not juggy then rawset(_G, "juggy", {}) end -- Create the juggy table if it doesn't exist.
-- Quit early if the last version loaded is higher than this local file.
if juggy.SENSBALLS_VERSION and juggy.SENSBALLS_VERSION > SENSBALLS_VERSION then return end
juggy.SENSBALLS_VERSION = SENSBALLS_VERSION -- This is the newest version now.
local function versioningDoesNotAllowIt() return juggy.SENSBALLS_VERSION > SENSBALLS_VERSION end

local sensBallsEnabled = false

local function isPositiveResult(value)
	local num = tonumber(value) or 0

	return string.lower(value) == "true" or
		string.lower(value) == "on" or
		string.lower(value) == "yes" or
		num > 0
end

addHook("MapChange", function(mapnum)
	if versioningDoesNotAllowIt() then return end
	local value = mapheaderinfo[mapnum].sensfortressballs
	
	if value and isPositiveResult(value) then
		sensBallsEnabled = true
	end
end)

addHook("NetVars", function(net)
	if versioningDoesNotAllowIt() then return end
	sensBallsEnabled = net($)
end)

addHook("MobjThinker", function(mobj)
	if versioningDoesNotAllowIt() then return end
	if not sensBallsEnabled then return end
	if not (mobj and mobj.valid) then return end
	mobj.threshold = 0 -- Never bounce.
	
end, MT_LSZ_EGGBALL)

addHook("MobjSpawn", function(mobj)
	if versioningDoesNotAllowIt() then return end
	if not sensBallsEnabled then return end
	
	mobj.flags = $|MF_DRAWFROMFARAWAY
end, MT_LSZ_EGGBALL)